local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/FrontierKeep1.fbx/Prefab/KeepPart", "PREFAB_FRONTIER_KEEP1")
mod:registerAssetId("models/FrontierKeep1.fbx/Prefab/LadderPart", "PREFAB_FRONTIER_LADDER1")
mod:registerAssetId("models/FrontierTower1.fbx/Prefab/TowerPart", "PREFAB_FRONTIER_TOWER1")
mod:registerAssetId("models/FrontierTower2.fbx/Prefab/TowerPart", "PREFAB_FRONTIER_TOWER2")
mod:registerAssetId("models/FrontierGate1.fbx/Prefab/GatePart", "PREFAB_FRONTIER_GATE1")
mod:registerAssetId("models/FrontierGate2.fbx/Prefab/GatePart", "PREFAB_FRONTIER_GATE2")
mod:registerAssetId("models/FrontierGate3.fbx/Prefab/GatePart", "PREFAB_FRONTIER_GATE3")

mod:registerAssetId("models/FrontierKeep1.fbx/Prefab/KeepConstruction", "PREFAB_CONSTR_FRONTIER_KEEP1")
mod:registerAssetId("models/FrontierTower1.fbx/Prefab/TowerConstruction", "PREFAB_CONSTR_FRONTIER_TOWER1")
mod:registerAssetId("models/FrontierTower2.fbx/Prefab/TowerConstruction", "PREFAB_CONSTR_FRONTIER_TOWER2")
mod:registerAssetId("models/FrontierGate1.fbx/Prefab/GateConstruction", "PREFAB_CONSTR_FRONTIER_GATE1")



-- Building Asset Processor
mod:registerAssetProcessor("models/FrontierKeep1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/FrontierTower1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/FrontierTower2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/FrontierGate1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding
-- mod:registerPrefabComponent("models/HighStreetBuilding1.fbx/Prefab/PlaceholderPart/Cube.001", {DataType = "COMP_GROUNDED"})



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/FrontierKeep1.fbx/Prefab/KeepPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/FrontierTower1.fbx/Prefab/TowerPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/FrontierTower2.fbx/Prefab/TowerPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/FrontierGate1.fbx/Prefab/GatePart", { "PLATFORM" })



-- Building: Frontier Fortifications -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_FRONTIER",
	Name = "BUILDING_FRONTIER_NAME",
	Description = "BUILDING_FRONTIER_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_FRONTIER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_FRONTIER_KEEP1",
				"BUILDING_PART_FRONTIER_TOWER1",
				"BUILDING_PART_FRONTIER_TOWER2",
				"BUILDING_PART_FRONTIER_GATE1",
				"BUILDING_PART_FRONTIER_GATE2",
				"BUILDING_PART_FRONTIER_GATE3",
			}
		},
		{
			Name = "BUILDING_SET_FRONTIER2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_FRONTIER_LADDER1",
			}
		},
    },
	-- RequiredPartList = {
	-- 	{ Category = "CORE", Min = 1, Max = 1 },
	-- },
	-- VillagerRequired = { Status = "SERF", Quantity = 10 },
	IsEditable = true
})



-- Building Part: Keep -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_KEEP1",
	Name = "BUILDING_PART_FRONTIER_KEEP1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_KEEP1"
	},
	ConstructionVisual = "PREFAB_CONSTR_FRONTIER_KEEP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7, 7}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
            { 
                Polygon = polygon.createRectangle( {2.0, 1.5}, {4.5, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_KEEP",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 50 },
		}
	}
})



-- Building Part: Tower 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_TOWER1",
	Name = "BUILDING_PART_FRONTIER_TOWER1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_TOWER1"
	},
	ConstructionVisual = "PREFAB_CONSTR_FRONTIER_TOWER1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_TOWER",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
		}
	}
})



-- Building Part: Tower 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_TOWER2",
	Name = "BUILDING_PART_FRONTIER_TOWER2_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_TOWER2"
	},
	ConstructionVisual = "PREFAB_CONSTR_FRONTIER_TOWER2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_TOWER",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
		}
	}
})



-- Building Part: Gate 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_GATE1",
	Name = "BUILDING_PART_FRONTIER_GATE1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_GATE1"
	},
	ConstructionVisual = "PREFAB_CONSTR_FRONTIER_GATE1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.75, 3.75}, {0.0, -4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {4.75, 3.75}, {0.0, 4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_TOWER",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 15 },
		}
	}
})



-- Building Part: Gate 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_GATE2",
	Name = "BUILDING_PART_FRONTIER_GATE2_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_GATE2"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_FRONTIER_GATE2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.6, 1.0}, {0.0, -2.25} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {0.6, 1.0}, {0.0, 2.25} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_TOWER",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Gate 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_GATE3",
	Name = "BUILDING_PART_FRONTIER_GATE3_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_GATE3"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_FRONTIER_GATE2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.6, 0.4}, {-1.4, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {0.6, 0.4}, {1.4, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_FRONTIER_TOWER",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 6 },
		}
	}
})



-- Building Part: Ladder -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_FRONTIER_LADDER1",
	Name = "BUILDING_PART_FRONTIER_LADDER1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FRONTIER_LADDER1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_FRONTIER_LADDER1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1, 1}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})
